/******** <lalVerbatim file="BlockBuildOutputCV"> ********
Author: Tibbits, M. M.
$Id: BlockBuildOutput.c,v 1.1 2002/01/24 23:08:04 jolien Exp $
********* </lalVerbatim> ********/

#include "BlockBuildOutput.h"

NRCSID( BLOCKBUILDOUTPUTC, "$Id: BlockBuildOutput.c,v 1.1 2002/01/24 23:08:04 jolien Exp $");

void BuildOutput
(
	LALStatus		*status,
	LALSearchOutput		*output,
	REAL8Vector		*input,
	BlockSearchParams	*params
)
{
  /*
   * The program name which appears in the PROGRAM field of
   * the SUMM_STATISTICS table
   */

	REAL8Vector	*tempVector	= NULL;
	dataBase	*dbEntry	= NULL;
	outPut		*outputArray	= NULL;
	UINT4		iterator	= 0;
	CHAR		*PROGRAM	= "Block";

	INITSTATUS( status, "BlockBuildOutput", BLOCKBUILDOUTPUTC );

	tempVector = ((REAL8Vector*)(input));

	/* Number of output objects */
	output->numOutput	= 1;
	output->result		= LALMalloc(sizeof(outPut));
	outputArray		= output->result;

	outputArray[0].indexNumber	= 9999;
	outputArray[0].search		= experimental;
	outputArray[0].significant	= 1;	/* 1 - IS significant */
	outputArray[0].states		= 0;
	outputArray[0].optional		= 0;

	/*
	 * Start a linked list of database entries - the head of the list
	 * starts with the "results" field
	 */

	outputArray[0].results = LALCalloc(1, sizeof(dataBase));
	dbEntry = outputArray[0].results;
	dbEntry->previous = 0;

	/* Program name */
	snprintf(dbEntry->tableName, dbNameLimit, "summ_statistics");
	snprintf(dbEntry->columnName, dbNameLimit, "program");

	dbEntry->type       = char_s_ptr;
	dbEntry->numberRows = 1;
	dbEntry->rows.chars = LALMalloc(sizeof(CHAR)*(strlen(PROGRAM) + 1) );
	strcpy(dbEntry->rows.chars, PROGRAM);
	dbEntry->rowDimensions = LALMalloc(sizeof(UINT4));

	/* Don't include terminating null */
	dbEntry->rowDimensions[0] = strlen(PROGRAM);

	dbEntry->next = LALCalloc(1, sizeof(dataBase));
	dbEntry->next->previous = dbEntry;
	dbEntry = dbEntry->next;

	/* Start time */
	snprintf(dbEntry->tableName, dbNameLimit, "summ_statistics");
	snprintf(dbEntry->columnName, dbNameLimit, "start_time");

	dbEntry->type       = int_4s;
	dbEntry->numberRows = 1;
	dbEntry->rows.int4s = LALMalloc( sizeof(INT4) );
	*(dbEntry->rows.int4s) = params->times.startSec;
	dbEntry->rowDimensions = NULL;

	dbEntry->next = LALCalloc(1, sizeof(dataBase));
	dbEntry->next->previous = dbEntry;
	dbEntry = dbEntry->next;

	snprintf(dbEntry->tableName, dbNameLimit, "summ_statistics");
	snprintf(dbEntry->columnName, dbNameLimit, "start_time_ns");

	dbEntry->type       = int_4s;
	dbEntry->numberRows = 1;
	dbEntry->rows.int4s = LALMalloc( sizeof(INT4) );
	*(dbEntry->rows.int4s) = params->times.startNan;
	dbEntry->rowDimensions = NULL;

	dbEntry->next = LALCalloc(1, sizeof(dataBase));
	dbEntry->next->previous = dbEntry;
	dbEntry = dbEntry->next;

	/* End time */
	snprintf(dbEntry->tableName, dbNameLimit, "summ_statistics");
	snprintf(dbEntry->columnName, dbNameLimit, "end_time");

	dbEntry->type       = int_4s;
	dbEntry->numberRows = 1;
	dbEntry->rows.int4s = LALMalloc( sizeof(INT4) );
	*(dbEntry->rows.int4s) = params->times.stopSec;
	dbEntry->rowDimensions = NULL;

	dbEntry->next = LALCalloc(1, sizeof(dataBase));
	dbEntry->next->previous = dbEntry;
	dbEntry = dbEntry->next;

	snprintf(dbEntry->tableName, dbNameLimit, "summ_statistics");
	snprintf(dbEntry->columnName, dbNameLimit, "end_time_ns");

	dbEntry->type       = int_4s;
	dbEntry->numberRows = 1;
	dbEntry->rows.int4s = LALMalloc( sizeof(INT4) );
	*(dbEntry->rows.int4s) = params->times.stopNan;
	dbEntry->rowDimensions = NULL;

	dbEntry->next = LALCalloc(1, sizeof(dataBase));
	dbEntry->next->previous = dbEntry;
	dbEntry = dbEntry->next;

	/* Number of samples */
	snprintf(dbEntry->tableName, dbNameLimit, "summ_statistics");
	snprintf(dbEntry->columnName, dbNameLimit, "samples");

	dbEntry->type       = int_4s;
	dbEntry->numberRows = 1;
	dbEntry->rows.int4s = LALMalloc( sizeof(INT4) );
	*(dbEntry->rows.int4s) = params->times.numberSamples;
	dbEntry->rowDimensions = NULL;

	dbEntry->next = LALCalloc(1, sizeof(dataBase));
	dbEntry->next->previous = dbEntry;
	dbEntry = dbEntry->next;

	/* Channel name */
	snprintf(dbEntry->tableName, dbNameLimit, "summ_statistics");
	snprintf(dbEntry->columnName, dbNameLimit, "channel");

	dbEntry->type       = char_s_ptr;
	dbEntry->numberRows = 1;
	dbEntry->rows.chars = LALMalloc(sizeof(CHAR)*(strlen(params->channel) + 1) );
	strcpy(dbEntry->rows.chars, params->channel);
	dbEntry->rowDimensions = LALMalloc(sizeof(UINT4));

	/* Don't include terminating null */
	dbEntry->rowDimensions[0] = strlen(params->channel);
	dbEntry->next = LALCalloc(1, sizeof(dataBase));
	dbEntry->next->previous = dbEntry;
	dbEntry = dbEntry->next;

	/*  Fill Database Entry */
	snprintf(dbEntry->tableName, dbNameLimit, "summ_statistics");
	snprintf(dbEntry->columnName, dbNameLimit,"average");

	dbEntry->type       = real_8;
	dbEntry->numberRows = tempVector->length;
	dbEntry->rowDimensions = NULL;
	dbEntry->rows.real8 = (REAL8*) LALMalloc(tempVector->length * sizeof(REAL8)); 

	for( iterator = 0; iterator < tempVector->length; iterator++)
	{
		dbEntry->rows.real8[iterator] = tempVector->data[iterator];
	}

	/* Terminate the list */
	dbEntry->next = 0;

	RETURN(status);
}
